# coding: utf-8

"""
    Mozart platform API

    API for interacting with the Mozart platform.

    The version of the OpenAPI document: 0.2.0
    Contact: support@bang-olufsen.dk
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional
from pydantic import BaseModel, StrictBool, StrictStr, field_validator
from pydantic import Field

try:
    from typing import Self
except ImportError:
    from typing_extensions import Self


class LgeTvSoundSettings(BaseModel):
    """
    LgeTvSoundSettings
    """  # noqa: E501

    digital_output: Optional[StrictStr] = Field(default=None, alias="digitalOutput")
    e_arc: Optional[StrictBool] = Field(default=None, alias="eArc")
    output: Optional[StrictStr] = None
    __properties: ClassVar[List[str]] = ["digitalOutput", "eArc", "output"]

    @field_validator("digital_output")
    def digital_output_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in ("auto", "passThrough", "pcm", "unknown"):
            raise ValueError(
                "must be one of enum values ('auto', 'passThrough', 'pcm', 'unknown')"
            )
        return value

    @field_validator("output")
    def output_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in (
            "tvSpeaker",
            "externalOptical",
            "externalArc",
            "bluetooth",
            "wisaSpeakers",
            "lineout",
            "headphone",
            "tvSpeakerAndExternalOptical",
            "tvSpeakerAndHeadphone",
            "tvSpeakerAndBluetooth",
            "externalArcBno",
            "unknown",
        ):
            raise ValueError(
                "must be one of enum values ('tvSpeaker', 'externalOptical', 'externalArc', 'bluetooth', 'wisaSpeakers', 'lineout', 'headphone', 'tvSpeakerAndExternalOptical', 'tvSpeakerAndHeadphone', 'tvSpeakerAndBluetooth', 'externalArcBno', 'unknown')"
            )
        return value

    model_config = {"populate_by_name": True, "validate_assignment": True}

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of LgeTvSoundSettings from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={},
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of LgeTvSoundSettings from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate(
            {
                "digitalOutput": obj.get("digitalOutput"),
                "eArc": obj.get("eArc"),
                "output": obj.get("output"),
            }
        )
        return _obj
